unit AnaMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Gauges, CheckLst, Menus;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Panel2: TPanel;
    Gauge1: TGauge;
    Gauge2: TGauge;
    Label7: TLabel;
    Label6: TLabel;
    Timer1: TTimer;
    Gauge3: TGauge;
    Label8: TLabel;
    Gauge4: TGauge;
    Label9: TLabel;
    Gauge5: TGauge;
    Label10: TLabel;
    Gauge6: TGauge;
    Label11: TLabel;
    Label12: TLabel;
    Gauge7: TGauge;
    Gauge8: TGauge;
    Label13: TLabel;
    Label14: TLabel;
    Gauge9: TGauge;
    Gauge10: TGauge;
    Label15: TLabel;
    Label16: TLabel;
    Gauge11: TGauge;
    Gauge12: TGauge;
    Label17: TLabel;
    Label18: TLabel;
    Gauge13: TGauge;
    Gauge14: TGauge;
    Label19: TLabel;
    Label20: TLabel;
    Gauge15: TGauge;
    Gauge16: TGauge;
    Label21: TLabel;
    Panel1: TPanel;
    Label4: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Label22: TLabel;
    Gauge17: TGauge;
    Gauge18: TGauge;
    Label23: TLabel;
    Label24: TLabel;
    Gauge19: TGauge;
    Gauge20: TGauge;
    Label25: TLabel;
    Label26: TLabel;
    Gauge21: TGauge;
    Gauge22: TGauge;
    Label27: TLabel;
    Label28: TLabel;
    Gauge23: TGauge;
    Gauge24: TGauge;
    Label29: TLabel;
    Label30: TLabel;
    CheckListBox1: TCheckListBox;
    CheckListBox2: TCheckListBox;
    Label31: TLabel;
    Label32: TLabel;
    MainMenu1: TMainMenu;
    Ende1: TMenuItem;
    Single: TCheckBox;
    SelectBoxTyp: TRadioGroup;
    procedure FormShow(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CheckListBox1ClickCheck(Sender: TObject);
    procedure Ende1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

Uses AnaDigIo;

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
VAR I:Integer;
begin
  CheckListbox1.Enabled:=false;
  For i:=0 to 7 do
    Checklistbox1.Checked[i]:=true;
  CheckListbox1.Enabled:=true;
  // Seng AnaDigIO initialsierien
  // Die Deiniatialisierung bei Programmende wird von der
  // Unit AnaDigIo automatisch durchgefhrt !! und auch entfalllen
  // Die korrekte Deinitialsierung und Portfreigabe ist somit immer
  // gewhrleistet
  If InitAnaDigIODevice(0) and IsAnaDigIOInitialized then
  begin
    Statusbar1.Panels[0].Text:='Init = OK ';
    Statusbar1.Panels[1].Text:='Vcc='+FloatToStrF(GetUDC,ffgeneral,4,0)+' V';
    Statusbar1.Panels[2].Text:='Vref='+FloatToStrF(GetADRefVoltage,ffgeneral,4,0)+' V';
    PutDAVolt(1,0,1);
    PutDAVolt(2,0,1);
    SetDigitalPortP0($FF);
    Timer1.Enabled:=true;
  end else Timer1.Enabled:=false;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  // Bei jeder nderung am Schieberegler auch den Analogport
  // aktualisieren
  Label2.Caption:=FloatToStr(Trackbar1.Position/10)+' V';
  PutDAVolt(1,Trackbar1.Position/10,1);
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  // Bei jeder nderung am Schieberegler auch den Analogport
  // aktualisieren
  Label3.Caption:=FloatToStr(Trackbar2.Position/10)+' V';
  PutDAVolt(2,Trackbar2.Position/10,1);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
Var Wert:Extended;
    Mask,Binwert:Byte;
    I:Integer;
    Differential:Boolean;
    BoxTyp:BoxType;
begin
  // AD-Kanle 1..12 lesen
  Differential:=Not Single.Checked;
  BoxTyp:=BoxType(SelectBoxTyp.ItemIndex);
  Wert:=GetADV(1,Mux(1,Differential,BoxTyp));
  Label7.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge1.Progress:=Round(Wert*10); Gauge2.Progress:=Round(Wert*10);
  Wert:=GetADV(1,Mux(2,Differential,BoxTyp));
  Label9.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge3.Progress:=Round(Wert*10); Gauge4.Progress:=Round(Wert*10);
  Wert:=GetADV(1,Mux(3,Differential,BoxTyp));
  Label11.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge5.Progress:=Round(Wert*10); Gauge6.Progress:=Round(Wert*10);
  Wert:=GetADV(1,Mux(4,Differential,BoxTyp));
  Label13.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge7.Progress:=Round(Wert*10); Gauge8.Progress:=Round(Wert*10);
  Wert:=GetADV(1,Mux(5,Differential,BoxTyp));
  Label15.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge9.Progress:=Round(Wert*10); Gauge10.Progress:=Round(Wert*10);
  Wert:=GetADV(1,Mux(6,Differential,BoxTyp));
  Label17.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge11.Progress:=Round(Wert*10); Gauge12.Progress:=Round(Wert*10);
  Wert:=GetADV(1,Mux(7,Differential,BoxTyp));
  Label19.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge13.Progress:=Round(Wert*10); Gauge14.Progress:=Round(Wert*10);
  Wert:=GetADV(1,Mux(8,Differential,BoxTyp));
  Label21.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge15.Progress:=Round(Wert*10); Gauge16.Progress:=Round(Wert*10);
  Wert:=GetADV(1,Mux(9,Differential,BoxTyp));
  Label23.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge17.Progress:=Round(Wert*10); Gauge18.Progress:=Round(Wert*10);
  Wert:=GetADV(1,Mux(10,Differential,BoxTyp));
  Label25.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge19.Progress:=Round(Wert*10); Gauge20.Progress:=Round(Wert*10);
  Wert:=GetADV(1,Mux(11,Differential,BoxTyp));
  Label27.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge21.Progress:=Round(Wert*10); Gauge22.Progress:=Round(Wert*10);
  Wert:=GetADV(1,Mux(12,Differential,BoxTyp));
  Label29.Caption:=FloatToStrF(Wert,fffixed,3,2)+' V';
  Gauge23.Progress:=Round(Wert*10); Gauge24.Progress:=Round(Wert*10);
  // Digital-Werte einlesen
  // und der Checklistbox zuweisen
  BinWert:=GetDigitalPortP1;
  Mask:=1;
  For i:=0 to 7 do
    begin
      CheckListBox2.Checked[i]:=(BinWert and Mask)>0;
      Mask:=Mask shl 1;
    end;
end;

procedure TForm1.CheckListBox1ClickCheck(Sender: TObject);
Var i:Integer;
    Mask,Wert:Byte;
begin
  // Immer wenn geclickt wird, muss der Digitalwert aktualisiert
  // werden....
  Mask:=1;
  Wert:=0;
  For i:=0 to 7 do
    begin
      If Checklistbox1.Checked[i] then
        Wert:=Wert or Mask;
      Mask:=Mask shl 1;
    end;
   SetDigitalPortP0(Wert);
end;

procedure TForm1.Ende1Click(Sender: TObject);
begin
   Application.Terminate;
end;

end.
