unit dehn_win_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, WstrTool, ExtCtrls, ComCtrls, StdCtrls, Buttons;

type
  THauptForm = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Einstellungen1: TMenuItem;
    Setup1: TMenuItem;
    Hilfe1: TMenuItem;
    Info1: TMenuItem;
    Ende1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    StatusBar1: TStatusBar;
    PageControl1: TPageControl;
    TabSheet_Start: TTabSheet;
    TabSheet_Tara: TTabSheet;
    TabSheet_Messung: TTabSheet;
    Button_Datei: TButton;
    Label_Bearbeiter: TLabel;
    Label_Kunde: TLabel;
    Label_Teil: TLabel;
    Label_Info1: TLabel;
    Edit_Bearb: TEdit;
    Edit_Kunde: TEdit;
    Edit_Teil: TEdit;
    Edit_Info1: TEdit;
    Edit_Info2: TEdit;
    Edit_Info3: TEdit;
    Edit_Info4: TEdit;
    Edit_FileName: TEdit;
    Label1: TLabel;
    Button_TaraSelect: TButton;
    Button_Messung: TButton;
    Button_StartTara: TButton;
    Label_Tara: TLabel;
    GroupBox1: TGroupBox;
    CheckBox_k1: TCheckBox;
    CheckBox_k2: TCheckBox;
    CheckBox_k3: TCheckBox;
    CheckBox_k4: TCheckBox;
    CheckBox_k5: TCheckBox;
    CheckBox_k6: TCheckBox;
    CheckBox_k8: TCheckBox;
    CheckBox_k7: TCheckBox;
    Panel_tara1: TPanel;
    Label_Kanal1: TLabel;
    Label_kanal2: TLabel;
    Label_Kanal3: TLabel;
    Label_kanal4: TLabel;
    Label_Kanal5: TLabel;
    Label_Kanal6: TLabel;
    Label_Kanal7: TLabel;
    Label_Kanal8: TLabel;
    Panel_tara2: TPanel;
    Panel_Tara3: TPanel;
    Panel_tara4: TPanel;
    Panel_tara5: TPanel;
    Panel_tara6: TPanel;
    Panel_tara7: TPanel;
    Panel_tara8: TPanel;
    Button_TaraZurueck: TButton;
    Button_TaraWeiter: TButton;
    Button_MessZurueck: TButton;
    Button_NeueMess: TButton;
    Button_Ende: TButton;
    Button_MessPause: TButton;
    Button_MessEnde: TButton;
    GroupBox_Messung: TGroupBox;
    SpeedButton_Messung: TSpeedButton;
    Label_Messunglaeuft: TLabel;
    Label_Werte: TLabel;
    Label_MKanal1: TLabel;
    Label_MKanal2: TLabel;
    Label_MKanal3: TLabel;
    Label_MKanal4: TLabel;
    Label_MKanal5: TLabel;
    Label_MKanal6: TLabel;
    Label_MKanal7: TLabel;
    Label_MKanal8: TLabel;
    Panel_MKanal1: TPanel;
    Panel_MKanal2: TPanel;
    Panel_MKanal3: TPanel;
    Panel_MKanal4: TPanel;
    Panel_MKanal5: TPanel;
    Panel_MKanal6: TPanel;
    Panel_MKanal7: TPanel;
    Panel_MKanal8: TPanel;
    Panel_MessNummer: TPanel;
    Panel_Datei: TPanel;
    Label_Datei: TLabel;
    Button_PrMessen: TButton;
    procedure Info1Click(Sender: TObject);
    procedure Ende1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Setup1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button_MessungClick(Sender: TObject);
    procedure Button_DateiClick(Sender: TObject);
    procedure Edit_FileNameChange(Sender: TObject);
    procedure Edit_BearbChange(Sender: TObject);
    procedure Edit_KundeChange(Sender: TObject);
    procedure Edit_TeilChange(Sender: TObject);
    procedure Button_TaraSelectClick(Sender: TObject);
    procedure Button_StartTaraClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button_TaraZurueckClick(Sender: TObject);
    procedure Button_TaraWeiterClick(Sender: TObject);
    procedure Button_EndeClick(Sender: TObject);
    procedure Button_NeueMessClick(Sender: TObject);
    procedure Button_MessZurueckClick(Sender: TObject);
    procedure Button_MessEndeClick(Sender: TObject);
    procedure Button_MessPauseClick(Sender: TObject);
    procedure Edit_FileNameExit(Sender: TObject);
    procedure Button_PrMessenClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  Procedure ProgrammEnde;
  Procedure Check_Header;
  Procedure HighPriority;
  Procedure NormalPriority;


end;

var
  HauptForm: THauptForm;

implementation




uses Info, Setup, AnaDigIo;

{$R *.DFM}
Const Header_Complete: Boolean = False;



Procedure THauptForm.Check_Header;
Begin
   If (Length(Edit_FileName.Text)>4) and
      (Length(Edit_Bearb.Text)>4) and
      (Length(Edit_Kunde.Text)>1) and
      (Length(Edit_Teil.Text)>4) then Header_Complete:=True
      else Header_Complete := False;
   If Header_Complete=True then
         Button_TaraSelect.Enabled:=True else
         Button_TaraSelect.Enabled:=False;

End;


Procedure THauptForm.HighPriority;
Begin
  SetPriorityClass(GetCurrentProcess,REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentProcess,THREAD_PRIORITY_TIME_CRITICAL);
end;

Procedure THauptForm.NormalPriority;
Begin
  SetPriorityClass(GetCurrentProcess,REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentProcess,THREAD_PRIORITY_TIME_CRITICAL);
end;


Procedure THauptForm.ProgrammEnde;

Begin
  If MessageDlg('Programm nun beenden ?',mtConfirmation,[mbYes, mbNo], 0) = MRYes
     Then
       Begin
         //ini_Schreiben;
         Application.Terminate;
       end;
End;


procedure THauptForm.Info1Click(Sender: TObject);
begin
   InfoForm1.Visible:=true;
   //Info.ShowModal;
end;


procedure THauptForm.Ende1Click(Sender: TObject);
begin
  ProgrammEnde;
end;

procedure THauptForm.FormCreate(Sender: TObject);
begin
   StartDir:=Home_DirName('');
    IniDirFileName:=Startdir+IniFileName;
   If Fileexists(IniDirFileName) then
   Ini_Lesen else
   begin
     Ini_Default;
     Ini_Schreiben;
   end;
If InitAnaDigIODevice(0) and IsAnaDigIOInitialized then
  begin
    Statusbar1.Panels[0].Text:='Init = OK ';
    Statusbar1.Panels[1].Text:='Vcc='+FloatToStrF(GetUDC,ffgeneral,4,0)+' V';
    Statusbar1.Panels[2].Text:='Vref='+FloatToStrF(GetADRefVoltage,ffgeneral,4,0)+' V';
    PutDAVolt(1,0,1);
    PutDAVolt(2,0,1);
    SetDigitalPortP0($FF);
  end;
   TabSheet_Start.TabVisible:=True;
   TabSheet_Messung.TabVisible:=False;
   TabSheet_Tara.TabVisible:=False;
   PageControl1.ActivePage:=TabSheet_Start;
   Messung_Laeuft:=False;
   PrMessung_Laeuft:=False;
end;

procedure THauptForm.Setup1Click(Sender: TObject);
begin
  SetupForm.ShowModal;
end;

procedure THauptForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ProgrammEnde;
end;

procedure THauptForm.Button_MessungClick(Sender: TObject);
Var ButtonText : String;
    k: integer;
begin
  if ini.SingleEnded=false then Differential:=true else Differential:=false;
  BoxTyp:=BoxType(ini.BoxenTyp);
  ButtonText:=Button_Messung.Caption;
  Timer1.Interval:=Round(1000/ini.AvgRate);
   Case ini.samplingdim of
     sek : SrateTotal:=ini.Samplingrate;
     min : SrateTotal:=ini.Samplingrate/60;
     hrs : SrateTotal:=ini.Samplingrate/3600;
   end; //of case
   AvgZeit:= ini.AvgSamples*(1/ini.avgrate);
   SRateLoops:=Round(((1/SRateTotal)-AvgZeit)*ini.AvgRate)-1;
   If SRateLoops<1 then SRateLoops:=1;
   Statusbar1.Panels[3].Text:='SRateLoops: '+IntToStr(SrateLoops);
   case Ini.SamplingDim of
     sek:   StatusBar1.Panels[4].Text:='Srate: '+IntToStr(ini.Samplingrate)+' Hz';
     min: StatusBar1.Panels[4].Text:='Srate: '+IntToStr(ini.Samplingrate)+' /min';
     Hrs: StatusBar1.Panels[4].Text:='Srate: '+IntToStr(ini.Samplingrate)+' /Std';
   end;  //of Case
   Button_PrMessen.Enabled:=false;
   Button_Messung.Enabled:=False;
   Button_MessPause.Enabled:=True;
   Button_MessEnde.Enabled:=True;
   Button_MessZurueck.Enabled:=False;
   Button_NeueMess.Enabled:=False;
   Button_Ende.Enabled:=False;
   Setup1.enabled:=False;
   For k:=1 to 8 do WertBuffer[k]:=0;
   AktLoop:=1;
   AvgLoops:=1;
   Try
     AssignFile(Datei,DateiName);
     ReWrite(Datei);
     DateiTextZeile:=';Startzeit     : '+DateTimeToStr(Now);
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Bearbeiter    : '+Edit_Bearb.Text;
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kunde         : '+Edit_Kunde.Text;
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Info1         : '+Edit_Info1.Text;
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Info2         : '+Edit_Info2.Text;
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Info3         : '+Edit_Info3.Text;
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Info4         : '+Edit_Info4.Text;
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';---------------------------------------------------';
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Offsets :';
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 1 : '+FloatToStrf(Ini.KoffSet[1],ffFixed,4,2)+' V';
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 2 : '+FloatToStrf(Ini.KoffSet[2],ffFixed,4,2)+' V';
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 3 : '+FloatToStrf(Ini.KoffSet[3],ffFixed,4,2)+' V';
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 4 : '+FloatToStrf(Ini.KoffSet[4],ffFixed,4,2)+' V';
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 5 : '+FloatToStrf(Ini.KoffSet[5],ffFixed,4,2)+' V';
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 6 : '+FloatToStrf(Ini.KoffSet[6],ffFixed,4,2)+' V';
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 7 : '+FloatToStrf(Ini.KoffSet[7],ffFixed,4,2)+' V';
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 8 : '+FloatToStrf(Ini.KoffSet[8],ffFixed,4,2)+' V';
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';---------------------------------------------------';
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Physikalische Einheiten:';
     Writeln(Datei,DateiTextZeile);
     case ini.SamplingDim of
        Sek: DateiTextZeile:=';Zeitachse (1.Kanal): Sekunden';
        Min: DateiTextZeile:=';Zeitachse (1.Kanal): Minuten';
        Hrs: DateiTextZeile:=';Zeitachse (1.Kanal): Stunden';
     end; //of case
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 1 :'+ini.Kdim[1];
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 2 :'+ini.Kdim[2];
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 3 :'+ini.Kdim[3];
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 4 :'+ini.Kdim[4];
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 5 :'+ini.Kdim[5];
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 6 :'+ini.Kdim[6];
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 7 :'+ini.Kdim[7];
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';Kanal 8 :'+ini.Kdim[8];
     Writeln(Datei,DateiTextZeile);
     DateiTextZeile:=';---------------------------------------------------';
     Writeln(Datei,DateiTextZeile);
     CloseFile(Datei);
     MittelungLaeuft:=False;
     HighPriority;
     StartZeit:=Now;
     Messung_Laeuft:=True;
     MessNummer:=1;
     Panel_MessNummer.Caption:=IntToStr(MessNummer);
     Panel_Datei.Caption:=DateiName;
   except
      ShowMessage('Fehler beim Schreiben der Datei, zurck zum Start !');
      TabSheet_Start.TabVisible:=True;
      TabSheet_Messung.TabVisible:=False;
      TabSheet_Tara.TabVisible:=False;
      PageControl1.ActivePage:=TabSheet_Start;
   end

end;

procedure THauptForm.Button_DateiClick(Sender: TObject);

begin
   SaveDialog1.InitialDir:=ini.DatenDir;
   if SaveDialog1.Execute then DateiName:=SaveDialog1.Filename;
   Edit_FileName.Text:=Dateiname;
   if FileExists(DateiName) then        
      if application.MessageBox('Die Datei ist vorhanden, berschreiben ?',
        'Datei berschreiben ?',
        MB_OKCANCEL + MB_DEFBUTTON1) = IDOK then
              begin
                Edit_FileName.Text:=Dateiname;
               end
               else
               begin
                 DateiName:='';
                Edit_FileName.Text:=Dateiname;
               end;
end;

procedure THauptForm.Edit_FileNameChange(Sender: TObject);
begin
  Check_Header;
end;

procedure THauptForm.Edit_BearbChange(Sender: TObject);
begin
   Check_Header;
end;

procedure THauptForm.Edit_KundeChange(Sender: TObject);
begin
   Check_Header;
end;

procedure THauptForm.Edit_TeilChange(Sender: TObject);
begin
   Check_Header;
end;

procedure THauptForm.Button_TaraSelectClick(Sender: TObject);
begin
   TabSheet_Start.TabVisible:=False;
   TabSheet_Messung.TabVisible:=False;
   TabSheet_Tara.TabVisible:=True;
   PageControl1.ActivePage:=TabSheet_Tara;
   Label_Tara.Caption:='Zum Starten der Tariermessung mssen alle Aufnehmer in Ausgangslage sein.';
   CheckBox_k1.checked:=ini.ktara[1];
   CheckBox_k2.checked:=ini.ktara[2];
   CheckBox_k3.checked:=ini.ktara[3];
   CheckBox_k4.checked:=ini.ktara[4];
   CheckBox_k5.checked:=ini.ktara[5];
   CheckBox_k6.checked:=ini.ktara[6];
   CheckBox_k7.checked:=ini.ktara[7];
   CheckBox_k8.checked:=ini.ktara[8];
   Button_StartTara.Visible:=True;
   Button_StartTara.Enabled:=True;
   Button_TaraWeiter.Enabled:=false;

end;



procedure THauptForm.Button_StartTaraClick(Sender: TObject);
Var x:integer;
begin
  Setup1.enabled:=false;
  Timer1.Interval:=Round(1000/ini.TaraSRate);
  Button_StartTara.Enabled:=false;
  Label_Tara.Caption:='Tarierung luft';
  For x:=1 to 8 do Wertbuffer[x]:=0;
  i:=Trunc(ini.TaraSRate*ini.TaraTime)+1;
  j:=1;
  if ini.SingleEnded=false then Differential:=true else Differential:=false;
  BoxTyp:=BoxType(ini.BoxenTyp);
  Button_startTara.Visible:=false;
  Tara_Laeuft:=True;
end;



procedure THauptForm.Timer1Timer(Sender: TObject);
Var k: integer;
begin
  //Tarierzyklus
  If Tara_Laeuft=True Then
  Begin
    For k:=1 to 8 do
     Begin
       WertBuffer[k]:= WertBuffer[k]+GetADV(1,Mux(k,Differential,BoxTyp));
       if ini.KTara[k]=True then Ini.KoffSet[k]:=WertBuffer[k]/j;
     end;
     inc(j);
     If j>i then
    Begin
      Button_StartTara.Enabled:=True;
      Label_Tara.Caption:='Tarierung erfolgreich';
      Tara_Laeuft:=False;
      Button_TaraWeiter.Enabled:=True;
      Setup1.enabled:=True;
     Panel_tara1.caption:=FloatToStrf(Ini.KoffSet[1],ffFixed,4,2)+' V';
     Panel_tara2.caption:=FloatToStrf(Ini.KoffSet[2],ffFixed,4,2)+' V';
     Panel_tara3.caption:=FloatToStrf(Ini.KoffSet[3],ffFixed,4,2)+' V';
     Panel_tara4.caption:=FloatToStrf(Ini.KoffSet[4],ffFixed,4,2)+' V';
     Panel_tara5.caption:=FloatToStrf(Ini.KoffSet[5],ffFixed,4,2)+' V';
     Panel_tara6.caption:=FloatToStrf(Ini.KoffSet[6],ffFixed,4,2)+' V';
     Panel_tara7.caption:=FloatToStrf(Ini.KoffSet[7],ffFixed,4,2)+' V';
     Panel_tara8.caption:=FloatToStrf(Ini.KoffSet[8],ffFixed,4,2)+' V';

    end;
  end;
  // Messzyklus
  If ((Messung_Laeuft=True) or (MittelungLaeuft=True)) then
  begin
     If AktLoop<SRateLoops then
       begin   //warte bis nchste Mittelung
         inc(AktLoop);
         AvgLoops:=1;
       end
       else
       begin  //Mittelung wird durchgefhrt
         if AvgLoops<=ini.AvgSamples then
           begin
             MittelungLaeuft:=True;
             Label_Messunglaeuft.Caption:='Messung luft';
             SpeedButton_Messung.enabled:=true;
             For K:=1 to 8 do
                 begin
                       RohWert[k]:=GetADV(1,Mux(k,Differential,BoxTyp));
                       MessWert[k]:=(((rohWert[k])-(ini.KOffset[k]))*(ini.KFact[k]));
                       WertBuffer[k]:=WertBuffer[k]+Messwert[k];
                 end;
                 inc(AvgLoops);
            end  //Mittelungen wurden durchgefhrt
            else
              begin
                 MittelungLaeuft:=False;
                 AktLoop:=1;
                 SpeedButton_Messung.enabled:=false;
                 Label_Messunglaeuft.Caption:='Warte auf nchste Messung';
                 For k:=1 to 8 do
                    begin
                      WertBuffer[k]:=WertBuffer[k]/(avgLoops-1);
                    end;
                 Panel_MKanal1.Caption:=FloatToStrf(WertBuffer[1],ffFixed,4,ini.KKomma[1])+ini.KDim[1];
                 Panel_MKanal2.Caption:=FloatToStrf(WertBuffer[2],ffFixed,4,ini.KKomma[2])+ini.KDim[2];
                 Panel_MKanal3.Caption:=FloatToStrf(WertBuffer[3],ffFixed,4,ini.KKomma[3])+ini.KDim[3];
                 Panel_MKanal4.Caption:=FloatToStrf(WertBuffer[4],ffFixed,4,ini.KKomma[4])+ini.KDim[4];
                 Panel_MKanal5.Caption:=FloatToStrf(WertBuffer[5],ffFixed,4,ini.KKomma[5])+ini.KDim[5];
                 Panel_MKanal6.Caption:=FloatToStrf(WertBuffer[6],ffFixed,4,ini.KKomma[6])+ini.KDim[6];
                 Panel_MKanal7.Caption:=FloatToStrf(WertBuffer[7],ffFixed,4,ini.KKomma[7])+ini.KDim[7];
                 Panel_MKanal8.Caption:=FloatToStrf(WertBuffer[8],ffFixed,4,ini.KKomma[8])+ini.KDim[8];
                 If PrMessung_Laeuft=false then
                  Begin
                    Case ini.samplingdim of
                      sek : DateiTextZeile:=FloattoStrF((3600*24*(Now-StartZeit)),ffFixed,6,4);
                      min : DateiTextZeile:=FloattoStrF((60*24*(Now-StartZeit)),ffFixed,6,4);
                      hrs : DateiTextZeile:=FloattoStrF((24*(Now-StartZeit)),ffFixed,6,4);
                    end;  //of case
                    DateiTextZeile:=DateiTextZeile+'   '+FloatToStrf(WertBuffer[1],ffFixed,4,ini.KKomma[1]);
                    DateiTextZeile:=DateiTextZeile+'   '+FloatToStrf(WertBuffer[2],ffFixed,4,ini.KKomma[2]);
                    DateiTextZeile:=DateiTextZeile+'   '+FloatToStrf(WertBuffer[3],ffFixed,4,ini.KKomma[3]);
                    DateiTextZeile:=DateiTextZeile+'   '+FloatToStrf(WertBuffer[4],ffFixed,4,ini.KKomma[4]);
                    DateiTextZeile:=DateiTextZeile+'   '+FloatToStrf(WertBuffer[5],ffFixed,4,ini.KKomma[5]);
                    DateiTextZeile:=DateiTextZeile+'   '+FloatToStrf(WertBuffer[6],ffFixed,4,ini.KKomma[6]);
                    DateiTextZeile:=DateiTextZeile+'   '+FloatToStrf(WertBuffer[7],ffFixed,4,ini.KKomma[7]);
                    DateiTextZeile:=DateiTextZeile+'   '+FloatToStrf(WertBuffer[8],ffFixed,4,ini.KKomma[8]);
                    Try
                      Append(Datei);
                      Writeln(Datei,DateiTextZeile);
                      CloseFile(Datei);
                    except
                      Messung_Laeuft:=False;
                      ShowMessage('Fehler beim Schreiben in Datei, Messung wurde abgebrochen !');
                      TabSheet_Start.TabVisible:=True;
                      TabSheet_Messung.TabVisible:=False;
                      TabSheet_Tara.TabVisible:=False;
                      PageControl1.ActivePage:=TabSheet_Start;
                    end;
                   end;
                 AvgLoops:=1;
                 For k:=1 to 8 do
                    begin
                      WertBuffer[k]:=0;
                    end;
                 inc(MessNummer);
                 Panel_MessNummer.Caption:=IntToStr(MessNummer);
              end;
       end;
  end;
end;

procedure THauptForm.Button_TaraZurueckClick(Sender: TObject);
begin
   TabSheet_Start.TabVisible:=True;
   TabSheet_Messung.TabVisible:=False;
   TabSheet_Tara.TabVisible:=False;
   PageControl1.ActivePage:=TabSheet_Start;
   Label_Tara.Caption:='Zum Starten der Tariermessung mssen alle Aufnehmer in Ausgangslage sein.';
   CheckBox_k1.checked:=ini.ktara[1];
   CheckBox_k2.checked:=ini.ktara[2];
   CheckBox_k3.checked:=ini.ktara[3];
   CheckBox_k4.checked:=ini.ktara[4];
   CheckBox_k5.checked:=ini.ktara[5];
   CheckBox_k6.checked:=ini.ktara[6];
   CheckBox_k7.checked:=ini.ktara[7];
   CheckBox_k8.checked:=ini.ktara[8];
   Button_StartTara.Visible:=True;
   Tara_Laeuft:=False;
end;

procedure THauptForm.Button_TaraWeiterClick(Sender: TObject);
begin
   TabSheet_Start.TabVisible:=false;
   TabSheet_Tara.TabVisible:=false;
   TabSheet_Messung.TabVisible:=true;
   PageControl1.ActivePage:=TabSheet_Messung;
   Tara_Laeuft:=False;
   Button_MessPause.Enabled:=False;
   Button_MessEnde.Enabled:=False;
   Button_Messung.Enabled:=True;
   Button_MessZurueck.Enabled:=True;
end;

procedure THauptForm.Button_EndeClick(Sender: TObject);
begin
  Programmende;
end;

procedure THauptForm.Button_NeueMessClick(Sender: TObject);
begin
   TabSheet_Start.TabVisible:=True;
   TabSheet_Messung.TabVisible:=False;
   TabSheet_Tara.TabVisible:=False;
   PageControl1.ActivePage:=TabSheet_Start;
   Label_Tara.Caption:='Zum Starten der Tariermessung mssen alle Aufnehmer in Ausgangslage sein.';
   CheckBox_k1.checked:=ini.ktara[1];
   CheckBox_k2.checked:=ini.ktara[2];
   CheckBox_k3.checked:=ini.ktara[3];
   CheckBox_k4.checked:=ini.ktara[4];
   CheckBox_k5.checked:=ini.ktara[5];
   CheckBox_k6.checked:=ini.ktara[6];
   CheckBox_k7.checked:=ini.ktara[7];
   CheckBox_k8.checked:=ini.ktara[8];
   Button_StartTara.Visible:=True;
   Tara_Laeuft:=False;
end;

procedure THauptForm.Button_MessZurueckClick(Sender: TObject);
begin
  TabSheet_Start.TabVisible:=False;
   TabSheet_Messung.TabVisible:=False;
   TabSheet_Tara.TabVisible:=True;
   PageControl1.ActivePage:=TabSheet_Tara;
   Label_Tara.Caption:='Zum Starten der Tariermessung mssen alle Aufnehmer in Ausgangslage sein.';
   CheckBox_k1.checked:=ini.ktara[1];
   CheckBox_k2.checked:=ini.ktara[2];
   CheckBox_k3.checked:=ini.ktara[3];
   CheckBox_k4.checked:=ini.ktara[4];
   CheckBox_k5.checked:=ini.ktara[5];
   CheckBox_k6.checked:=ini.ktara[6];
   CheckBox_k7.checked:=ini.ktara[7];
   CheckBox_k8.checked:=ini.ktara[8];
   Button_StartTara.Visible:=True;
   Button_StartTara.Enabled:=True;
   Button_TaraWeiter.Enabled:=false;
end;

procedure THauptForm.Button_MessEndeClick(Sender: TObject);
begin
   NormalPriority;
   Button_PrMessen.Enabled:=True;
   Button_Messung.Enabled:=False;
   Button_MessPause.Enabled:=False;
   Button_MessEnde.Enabled:=false;
   Button_MessZurueck.Enabled:=False;
   Button_NeueMess.Enabled:=True;
   Button_Ende.Enabled:=True;
   Setup1.enabled:=True;
   Messung_Laeuft:=False;
end;

procedure THauptForm.Button_MessPauseClick(Sender: TObject);
begin
   If Messung_laeuft=true then
    begin
       Messung_Laeuft:=false;
       Button_MessPause.Caption:='Weiter';
       NormalPriority;
    end
    else
    begin
       Messung_Laeuft:=True;
       Button_MessPause.Caption:='Pause';
       HighPriority;
    end;
end;

procedure THauptForm.Edit_FileNameExit(Sender: TObject);
begin
DateiName:=Edit_FileName.Text;
If Length(Dateiname)>0 then
    if Length(ExtractFileext(Dateiname))=0 then Dateiname:=Dateiname+'.asc';
Edit_FileName.Text:=DateiName;
  if FileExists(DateiName) then
      if application.MessageBox('Die Datei ist vorhanden, berschreiben ?',
        'Datei berschreiben ?',
        MB_OKCANCEL + MB_DEFBUTTON1) = IDOK then
              begin
                Edit_FileName.Text:=Dateiname;
               end
               else
               begin
                 DateiName:='';
                Edit_FileName.Text:=Dateiname;
               end;

end;

procedure THauptForm.Button_PrMessenClick(Sender: TObject);
Var ButtonText : String;
    k: integer;
begin
  If Button_PrMessen.Caption='Probemessen' then
    Begin           //Probemessen starten
      HighPriority;
      Messung_Laeuft:=true;
      MittelungLaeuft:=true;
      PrMessung_Laeuft:=True;
      Button_PrMessen.Caption:='Probe stoppen';
      if ini.SingleEnded=false then Differential:=true else Differential:=false;
      BoxTyp:=BoxType(ini.BoxenTyp);
      ButtonText:=Button_Messung.Caption;
      Timer1.Interval:=10;
      SrateTotal:=10;
      AvgZeit:= 0.1;
      SRateLoops:=5;
      Statusbar1.Panels[3].Text:='SRateLoops: '+IntToStr(SrateLoops);
      StatusBar1.Panels[4].Text:='Srate: 10Hz';
      Button_Messung.Enabled:=False;
      Button_MessPause.Enabled:=False;
      Button_MessEnde.Enabled:=False;
      Button_MessZurueck.Enabled:=False;
      Button_NeueMess.Enabled:=False;
      Button_Ende.Enabled:=False;
      Setup1.enabled:=False;
      For k:=1 to 8 do WertBuffer[k]:=0;
      AktLoop:=1;
      AvgLoops:=1;
      MessNummer:=1;
      Panel_MessNummer.Caption:=IntToStr(MessNummer);
      Panel_Datei.Caption:='Probemessung luft';
    end
    else
    Begin              //Probemessen abbrechen
      Button_PrMessen.Caption:='Probemessen';
      Messung_Laeuft:=False;
      MittelungLaeuft:=False;
      PrMessung_Laeuft:=false;
      Statusbar1.Panels[3].Text:='SRateLoops: ';
      StatusBar1.Panels[4].Text:='Srate:';
      Button_Messung.Enabled:=True;
      Button_MessPause.Enabled:=False;
      Button_MessEnde.Enabled:=False;
      Button_MessZurueck.Enabled:=True;
      Button_NeueMess.Enabled:=True;
      Button_Ende.Enabled:=True;
      Setup1.enabled:=True;
      Panel_Datei.Caption:='';
      NormalPriority;
    end;
  End;

end.
